import * as i0 from '@angular/core';
import { Injectable, Component, Input, NgModule } from '@angular/core';
import { __awaiter } from 'tslib';
import { CommonModule } from '@angular/common';

class TagHighlightService {
    constructor() { }
}
TagHighlightService.ɵprov = i0.ɵɵdefineInjectable({ factory: function TagHighlightService_Factory() { return new TagHighlightService(); }, token: TagHighlightService, providedIn: "root" });
TagHighlightService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
TagHighlightService.ctorParameters = () => [];

class TagHighlightComponent {
    constructor() {
        this.multiSelect = false;
        this.isShowOnlySelected = false;
        this.isMoreThenNull = false;
        this.mainAreaTmp = new Set();
        this.selectMainAreaArray = [];
    }
    ngOnInit() {
        return __awaiter(this, void 0, void 0, function* () {
            console.log('Data', this.data);
            this.data.tagHighlight.tags.forEach((tag) => {
                this.mainAreaTmp.add(tag.thMainArea);
            });
            this.multiSelect = this.data.tagHighlight.thMultiselect;
            this.isShowOnlySelected = this.data.tagHighlight.thShowOnlySelected;
            this.isMoreThenNull = false;
        });
    }
    setActiveArea(e) {
        const currentValue = e.target.textContent;
        if (!this.multiSelect) {
            if (this.selectMainAreaArray.indexOf(currentValue) > -1) {
                this.selectMainAreaArray = [];
            }
            else {
                this.selectMainAreaArray = [];
                this.selectMainAreaArray.push(currentValue);
            }
        }
        else {
            let elemExists = false;
            if (this.selectMainAreaArray.length > 0) {
                for (let i = 0; i < this.selectMainAreaArray.length; i++) {
                    if (this.selectMainAreaArray[i] === currentValue) {
                        this.selectMainAreaArray.splice(i, 1);
                        elemExists = true;
                        break;
                    }
                }
                if (!elemExists) {
                    this.selectMainAreaArray.push(currentValue);
                }
            }
            else {
                this.selectMainAreaArray.push(currentValue);
            }
        }
        if (this.isShowOnlySelected) {
            this.isMoreThenNull = this.selectMainAreaArray.length > 0;
        }
    }
}
TagHighlightComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-tag-highlight',
                template: "<div class=\"tag-highlight\" *ngIf=\"data\">\n  <div class=\"th-head\">\n    <p class=\" title\">{{data.tagHighlight.thTitle}}</p>\n  </div>\n  <div class=\"th-main-area\">\n    <ng-container *ngFor=\"let ma of mainAreaTmp; let i = index; first as isFirst; last as isLast; odd as isOdd; even as isEven\">\n      <span\n          [ngClass] = \"[isLast?'last':'', isFirst?'first':'', isOdd?'odd':'', isEven?'even':'', 'ma', 'ma-'+i, selectMainAreaArray.indexOf(ma)>-1?'active':'']\"\n          (click)=\"setActiveArea($event)\"\n      >{{ma}}</span>\n    </ng-container>\n  </div>\n  <div class=\"th-tags d-flex justify-content-star flex-wrap\">\n    <ng-container *ngFor=\"let tag of data.tagHighlight.tags; let i = index; first as isFirst; last as isLast; odd as isOdd; even as isEven\">\n       <span\n           [ngClass] = \"[isLast?'last':'', isFirst?'first':'', isOdd?'odd':'', isEven?'even':'', 'tag', 'tag-'+i,\n                        selectMainAreaArray.indexOf(tag.thMainArea)>-1?'active':isMoreThenNull?'hidden':'']\"\n           [attr.main-area] = \"tag.thMainArea\"\n       >{{tag.tag}}</span>\n    </ng-container>\n  </div>\n</div>\n\n\n",
                styles: [".tag-highlight .th-main-area{margin-top:10px;margin-bottom:30px;overflow-x:auto;overflow-y:hidden;display:flex}.tag-highlight .th-main-area .ma{border:1px solid #eee;border-radius:40px;padding:13px 20px 14px;margin-right:15px;cursor:pointer;background-color:#eee;color:#222121;min-width:-moz-fit-content;min-width:fit-content}.tag-highlight .th-main-area .ma.last{margin-right:0}.tag-highlight .th-main-area .ma.active{background-color:#ea1d89;color:#fff;border-color:#ea1d89}.tag-highlight .th-tags{margin-top:10px}.tag-highlight .th-tags .tag{line-height:1;border:1px solid #afafaf;border-radius:40px;padding:10px 20px;margin-right:15px;margin-bottom:15px}.tag-highlight .th-tags .tag.last{margin-right:0}.tag-highlight .th-tags .tag.active{color:#ea1d89;border-color:#ea1d89}@media only screen and (max-width: 768px){.tag-highlight .th-tags .tag.hidden{display:none}}\n"]
            },] }
];
TagHighlightComponent.ctorParameters = () => [];
TagHighlightComponent.propDecorators = {
    data: [{ type: Input }]
};

class TagHighlightModule {
}
TagHighlightModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    TagHighlightComponent
                ],
                imports: [
                    CommonModule
                ],
                exports: [
                    TagHighlightComponent
                ]
            },] }
];

/*
 * Public API Surface of tag-highlight
 */

/**
 * Generated bundle index. Do not edit.
 */

export { TagHighlightComponent, TagHighlightModule, TagHighlightService };
//# sourceMappingURL=tag-highlight.js.map
